#if 0
#elif defined(__arm64__) && __arm64__
// Generated by Apple Swift version 5.7.1 (swiftlang-5.7.1.135.3 clang-1400.0.29.51)
#ifndef AMPCORE_SWIFT_H
#define AMPCORE_SWIFT_H
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wgcc-compat"

#if !defined(__has_include)
# define __has_include(x) 0
#endif
#if !defined(__has_attribute)
# define __has_attribute(x) 0
#endif
#if !defined(__has_feature)
# define __has_feature(x) 0
#endif
#if !defined(__has_warning)
# define __has_warning(x) 0
#endif

#if __has_include(<swift/objc-prologue.h>)
# include <swift/objc-prologue.h>
#endif

#pragma clang diagnostic ignored "-Wduplicate-method-match"
#pragma clang diagnostic ignored "-Wauto-import"
#if defined(__OBJC__)
#include <Foundation/Foundation.h>
#endif
#if defined(__cplusplus)
#include <cstdint>
#include <cstddef>
#include <cstdbool>
#else
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>
#endif

#if !defined(SWIFT_TYPEDEFS)
# define SWIFT_TYPEDEFS 1
# if __has_include(<uchar.h>)
#  include <uchar.h>
# elif !defined(__cplusplus)
typedef uint_least16_t char16_t;
typedef uint_least32_t char32_t;
# endif
typedef float swift_float2  __attribute__((__ext_vector_type__(2)));
typedef float swift_float3  __attribute__((__ext_vector_type__(3)));
typedef float swift_float4  __attribute__((__ext_vector_type__(4)));
typedef double swift_double2  __attribute__((__ext_vector_type__(2)));
typedef double swift_double3  __attribute__((__ext_vector_type__(3)));
typedef double swift_double4  __attribute__((__ext_vector_type__(4)));
typedef int swift_int2  __attribute__((__ext_vector_type__(2)));
typedef int swift_int3  __attribute__((__ext_vector_type__(3)));
typedef int swift_int4  __attribute__((__ext_vector_type__(4)));
typedef unsigned int swift_uint2  __attribute__((__ext_vector_type__(2)));
typedef unsigned int swift_uint3  __attribute__((__ext_vector_type__(3)));
typedef unsigned int swift_uint4  __attribute__((__ext_vector_type__(4)));
#endif

#if !defined(SWIFT_PASTE)
# define SWIFT_PASTE_HELPER(x, y) x##y
# define SWIFT_PASTE(x, y) SWIFT_PASTE_HELPER(x, y)
#endif
#if !defined(SWIFT_METATYPE)
# define SWIFT_METATYPE(X) Class
#endif
#if !defined(SWIFT_CLASS_PROPERTY)
# if __has_feature(objc_class_property)
#  define SWIFT_CLASS_PROPERTY(...) __VA_ARGS__
# else
#  define SWIFT_CLASS_PROPERTY(...)
# endif
#endif

#if __has_attribute(objc_runtime_name)
# define SWIFT_RUNTIME_NAME(X) __attribute__((objc_runtime_name(X)))
#else
# define SWIFT_RUNTIME_NAME(X)
#endif
#if __has_attribute(swift_name)
# define SWIFT_COMPILE_NAME(X) __attribute__((swift_name(X)))
#else
# define SWIFT_COMPILE_NAME(X)
#endif
#if __has_attribute(objc_method_family)
# define SWIFT_METHOD_FAMILY(X) __attribute__((objc_method_family(X)))
#else
# define SWIFT_METHOD_FAMILY(X)
#endif
#if __has_attribute(noescape)
# define SWIFT_NOESCAPE __attribute__((noescape))
#else
# define SWIFT_NOESCAPE
#endif
#if __has_attribute(ns_consumed)
# define SWIFT_RELEASES_ARGUMENT __attribute__((ns_consumed))
#else
# define SWIFT_RELEASES_ARGUMENT
#endif
#if __has_attribute(warn_unused_result)
# define SWIFT_WARN_UNUSED_RESULT __attribute__((warn_unused_result))
#else
# define SWIFT_WARN_UNUSED_RESULT
#endif
#if __has_attribute(noreturn)
# define SWIFT_NORETURN __attribute__((noreturn))
#else
# define SWIFT_NORETURN
#endif
#if !defined(SWIFT_CLASS_EXTRA)
# define SWIFT_CLASS_EXTRA
#endif
#if !defined(SWIFT_PROTOCOL_EXTRA)
# define SWIFT_PROTOCOL_EXTRA
#endif
#if !defined(SWIFT_ENUM_EXTRA)
# define SWIFT_ENUM_EXTRA
#endif
#if !defined(SWIFT_CLASS)
# if __has_attribute(objc_subclassing_restricted)
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_subclassing_restricted)) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# else
#  define SWIFT_CLASS(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
#  define SWIFT_CLASS_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_CLASS_EXTRA
# endif
#endif
#if !defined(SWIFT_RESILIENT_CLASS)
# if __has_attribute(objc_class_stub)
#  define SWIFT_RESILIENT_CLASS(SWIFT_NAME) SWIFT_CLASS(SWIFT_NAME) __attribute__((objc_class_stub))
#  define SWIFT_RESILIENT_CLASS_NAMED(SWIFT_NAME) __attribute__((objc_class_stub)) SWIFT_CLASS_NAMED(SWIFT_NAME)
# else
#  define SWIFT_RESILIENT_CLASS(SWIFT_NAME) SWIFT_CLASS(SWIFT_NAME)
#  define SWIFT_RESILIENT_CLASS_NAMED(SWIFT_NAME) SWIFT_CLASS_NAMED(SWIFT_NAME)
# endif
#endif

#if !defined(SWIFT_PROTOCOL)
# define SWIFT_PROTOCOL(SWIFT_NAME) SWIFT_RUNTIME_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
# define SWIFT_PROTOCOL_NAMED(SWIFT_NAME) SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_PROTOCOL_EXTRA
#endif

#if !defined(SWIFT_EXTENSION)
# define SWIFT_EXTENSION(M) SWIFT_PASTE(M##_Swift_, __LINE__)
#endif

#if !defined(OBJC_DESIGNATED_INITIALIZER)
# if __has_attribute(objc_designated_initializer)
#  define OBJC_DESIGNATED_INITIALIZER __attribute__((objc_designated_initializer))
# else
#  define OBJC_DESIGNATED_INITIALIZER
# endif
#endif
#if !defined(SWIFT_ENUM_ATTR)
# if defined(__has_attribute) && __has_attribute(enum_extensibility)
#  define SWIFT_ENUM_ATTR(_extensibility) __attribute__((enum_extensibility(_extensibility)))
# else
#  define SWIFT_ENUM_ATTR(_extensibility)
# endif
#endif
#if !defined(SWIFT_ENUM)
# define SWIFT_ENUM(_type, _name, _extensibility) enum _name : _type _name; enum SWIFT_ENUM_ATTR(_extensibility) SWIFT_ENUM_EXTRA _name : _type
# if __has_feature(generalized_swift_name)
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME, _extensibility) enum _name : _type _name SWIFT_COMPILE_NAME(SWIFT_NAME); enum SWIFT_COMPILE_NAME(SWIFT_NAME) SWIFT_ENUM_ATTR(_extensibility) SWIFT_ENUM_EXTRA _name : _type
# else
#  define SWIFT_ENUM_NAMED(_type, _name, SWIFT_NAME, _extensibility) SWIFT_ENUM(_type, _name, _extensibility)
# endif
#endif
#if !defined(SWIFT_UNAVAILABLE)
# define SWIFT_UNAVAILABLE __attribute__((unavailable))
#endif
#if !defined(SWIFT_UNAVAILABLE_MSG)
# define SWIFT_UNAVAILABLE_MSG(msg) __attribute__((unavailable(msg)))
#endif
#if !defined(SWIFT_AVAILABILITY)
# define SWIFT_AVAILABILITY(plat, ...) __attribute__((availability(plat, __VA_ARGS__)))
#endif
#if !defined(SWIFT_WEAK_IMPORT)
# define SWIFT_WEAK_IMPORT __attribute__((weak_import))
#endif
#if !defined(SWIFT_DEPRECATED)
# define SWIFT_DEPRECATED __attribute__((deprecated))
#endif
#if !defined(SWIFT_DEPRECATED_MSG)
# define SWIFT_DEPRECATED_MSG(...) __attribute__((deprecated(__VA_ARGS__)))
#endif
#if __has_feature(attribute_diagnose_if_objc)
# define SWIFT_DEPRECATED_OBJC(Msg) __attribute__((diagnose_if(1, Msg, "warning")))
#else
# define SWIFT_DEPRECATED_OBJC(Msg) SWIFT_DEPRECATED_MSG(Msg)
#endif
#if defined(__OBJC__)
#if !defined(IBSegueAction)
# define IBSegueAction
#endif
#endif
#if !defined(SWIFT_EXTERN)
# if defined(__cplusplus)
#  define SWIFT_EXTERN extern "C"
# else
#  define SWIFT_EXTERN extern
# endif
#endif
#if !defined(SWIFT_CALL)
# define SWIFT_CALL __attribute__((swiftcall))
#endif
#if defined(__cplusplus)
#if !defined(SWIFT_NOEXCEPT)
# define SWIFT_NOEXCEPT noexcept
#endif
#else
#if !defined(SWIFT_NOEXCEPT)
# define SWIFT_NOEXCEPT 
#endif
#endif
#if defined(__cplusplus)
#if !defined(SWIFT_CXX_INT_DEFINED)
#define SWIFT_CXX_INT_DEFINED
namespace swift {
using Int = ptrdiff_t;
using UInt = size_t;
}
#endif
#endif
#if defined(__OBJC__)
#if __has_feature(modules)
#if __has_warning("-Watimport-in-framework-header")
#pragma clang diagnostic ignored "-Watimport-in-framework-header"
#endif
@import CoreFoundation;
@import Foundation;
@import ObjectiveC;
@import UIKit;
#endif

#endif
#pragma clang diagnostic ignored "-Wproperty-attribute-mismatch"
#pragma clang diagnostic ignored "-Wduplicate-method-arg"
#if __has_warning("-Wpragma-clang-attribute")
# pragma clang diagnostic ignored "-Wpragma-clang-attribute"
#endif
#pragma clang diagnostic ignored "-Wunknown-pragmas"
#pragma clang diagnostic ignored "-Wnullability"
#pragma clang diagnostic ignored "-Wdollar-in-identifier-extension"

#if __has_attribute(external_source_symbol)
# pragma push_macro("any")
# undef any
# pragma clang attribute push(__attribute__((external_source_symbol(language="Swift", defined_in="AmpCore",generated_declaration))), apply_to=any(function,enum,objc_interface,objc_category,objc_protocol))
# pragma pop_macro("any")
#endif

#if defined(__OBJC__)


/// Container class for all the information related to the active ad break
SWIFT_CLASS("_TtC7AmpCore11AdBreakInfo")
@interface AdBreakInfo : NSObject
/// Creates a container of the ad break information
/// The <code>breakIndex</code> parameter should be:
/// <ul>
///   <li>
///     0 when the break is a preroll
///   </li>
///   <li>
///     1 when the break is a midroll
///   </li>
///   <li>
///     2 when the break is a postroll
///   </li>
/// </ul>
/// \param totalAds number of ads that the ad break contains
///
/// \param duration total duration of the ad break in seconds
///
/// \param breakIndex position of the ad break inside the main content timeline
///
- (nonnull instancetype)initWithTotalAds:(NSInteger)totalAds duration:(double)duration breakIndex:(NSInteger)breakIndex OBJC_DESIGNATED_INITIALIZER;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end

@class NSString;

/// Container object of the general information of an Ad.
SWIFT_CLASS("_TtC7AmpCore6AdInfo")
@interface AdInfo : NSObject
/// Creates a new instance of the AdInfo object
/// The default value of the vendor will be <code>AdVendor/GOOGLE</code>
/// \param title String representation of the title of the stream
///
/// \param adDescription String representation of the description of the stream
///
/// \param position Value of the position of the ad. There is no restriccion in regards to the
/// value this parameter must have.
///
/// \param duration Duration of the ad in seconds
///
/// \param vendor Ad provider company
///
- (nonnull instancetype)initWithTitle:(NSString * _Nonnull)title adDescription:(NSString * _Nonnull)adDescription position:(NSInteger)position duration:(double)duration vendor:(NSString * _Nonnull)vendor OBJC_DESIGNATED_INITIALIZER;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end


/// Third-party ads provider list
SWIFT_CLASS("_TtC7AmpCore8AdVendor")
@interface AdVendor : NSObject
/// <a href="https://www.freewheel.com/">Freewheel</a>
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, copy) NSString * _Nonnull FREEWHEEL;)
+ (NSString * _Nonnull)FREEWHEEL SWIFT_WARN_UNUSED_RESULT;
+ (void)setFREEWHEEL:(NSString * _Nonnull)value;
/// <a href="https://developers.google.com/interactive-media-ads">Google IMA</a>
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, copy) NSString * _Nonnull GOOGLE;)
+ (NSString * _Nonnull)GOOGLE SWIFT_WARN_UNUSED_RESULT;
+ (void)setGOOGLE:(NSString * _Nonnull)value;
/// <a href="https://www.yospace.com/">YoSpace</a>
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, copy) NSString * _Nonnull YOSPACE;)
+ (NSString * _Nonnull)YOSPACE SWIFT_WARN_UNUSED_RESULT;
+ (void)setYOSPACE:(NSString * _Nonnull)value;
- (nonnull instancetype)init OBJC_DESIGNATED_INITIALIZER;
@end

@class NSCoder;

SWIFT_CLASS("_TtC7AmpCore9AmpButton")
@interface AmpButton : UIButton
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
- (void)handleTouch:(id _Nonnull)sender;
- (nonnull instancetype)initWithFrame:(CGRect)frame SWIFT_UNAVAILABLE;
@end

@class UIColor;

SWIFT_CLASS("_TtC7AmpCore17AmpAirplay2Button")
@interface AmpAirplay2Button : AmpButton
@property (nonatomic, strong) UIColor * _Nullable tintColor;
- (void)handleTouch:(id _Nonnull)sender;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore16AmpAirplayButton")
@interface AmpAirplayButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


@class AmpPlayer;
enum PlayerError : NSInteger;
@class StreamInfo;
@class AVMetadataItem;
@class AVAssetTrack;
@class OTTDevice;

/// Protocol used to receive player events.
SWIFT_PROTOCOL("_TtP7AmpCore19PlayerEventObserver_")
@protocol PlayerEventObserver
@optional
/// Callback triggered when the player is about to handle a new URL
/// \param ampPlayer Instance of the player sending the event
///
- (void)willHandleUrl:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback triggered when a pluging handles the initial connection to the stream.
- (void)willRequestStream;
/// Callback triggered when the internal player is created successfully
/// \param ampPlayer Instance of the player sending the event
///
- (void)onAVPlayerCreation:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback triggered when external playback delegate has changed
/// \param ampPlayer Instance of the player sending the event
///
- (void)onExternalPlaybackChange:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player experiences an error.
/// \param ampPlayer The instance of the player that sends the event.
///
/// \param error The error sent.
///
- (void)onAmpError:(AmpPlayer * _Nonnull)ampPlayer error:(enum PlayerError)error code:(NSInteger)code message:(NSString * _Nonnull)message;
/// Callback called when the playback state of the player changes.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onPlaybackStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onAmpPlaybackStateChanged:(AmpPlayer * _Nonnull)ampPlayer SWIFT_UNAVAILABLE_MSG("'onAmpPlaybackStateChanged' has been renamed to 'onPlaybackStateChanged:'");
/// Callback called when the buffering state of the player changes.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onBufferingStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onAmpBufferingStateChanged:(AmpPlayer * _Nonnull)ampPlayer SWIFT_UNAVAILABLE_MSG("'onAmpBufferingStateChanged' has been renamed to 'onBufferingStateChanged:'");
/// Callback called when the bitrate of the player changes.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onBitrateChanged:(AmpPlayer * _Nonnull)ampPlayer bitrate:(double)bitrate;
/// Callback called when the audio bitrate of the player changes.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onAudioTrackChanged:(AmpPlayer * _Nonnull)ampPlayer name:(NSString * _Nonnull)name;
/// Callback called when the position of the player changes.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onPositionChange:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onAmpPositionChange:(AmpPlayer * _Nonnull)ampPlayer SWIFT_UNAVAILABLE_MSG("'onAmpPositionChange' has been renamed to 'onPositionChange:'");
/// Callback called when the seconds of the player changes.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onTimeChange:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onAmpTimeChange:(AmpPlayer * _Nonnull)ampPlayer SWIFT_UNAVAILABLE_MSG("'onAmpTimeChange' has been renamed to 'onTimeChange:'");
/// Callback called when the position of the player changes.
/// \param ampPlayer The instance of the player that sends the event.
///
/// \param atTime The time of the cuepoint reached.
///
- (void)onCuepointReached:(AmpPlayer * _Nonnull)ampPlayer atTime:(double)atTime;
- (void)onAmpCuepointReached:(AmpPlayer * _Nonnull)ampPlayer atTime:(double)atTime SWIFT_UNAVAILABLE_MSG("'onAmpCuepointReached' has been renamed to 'onCuepointReached(_:)'");
/// Callback called when the playback of the player ends.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onPlaybackEnded:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onAmpPlaybackEnded:(AmpPlayer * _Nonnull)ampPlayer SWIFT_UNAVAILABLE_MSG("'onAmpPlaybackEnded' has been renamed to 'onPlaybackEnded:'");
/// Callback called when the player is going to be replayed.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onReplay:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onAmpReplay:(AmpPlayer * _Nonnull)ampPlayer SWIFT_UNAVAILABLE_MSG("'onAmpReplay' has been renamed to 'onReplay:'");
/// Callback triggered when the player handled the AVPlayerItemPlaybackStalled notification.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onPlaybackStalled:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player handled the UIApplicationWillResignActiveNotification notification.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onHandledResignActive:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player handled the UIApplicationDidBecomeActiveNotification notification.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onHandledDidBecomeActive:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player handled the AVPlayerItemNewAccessLogEntry notification.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onHandleAVPlayerAccess:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the streams information changes.
/// \param ampPlayer The instance of the player that sends the event.
///
/// \param streamInfo The struct representing the Stream’s Information.
///
- (void)onStreamInformationChanged:(AmpPlayer * _Nonnull)ampPlayer streamInfo:(StreamInfo * _Nonnull)streamInfo;
/// Callback called when the player is going to be stopped.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player logs are enabled.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onEnableLogs:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player logs are disabled.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onDisableLogs:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when a time metadata (ID3Tag) is reached.
/// \param ampPlayer The instance of the player that sends the event.
///
/// \param metadata The array of metadata reached
///
- (void)onTimedMetadata:(AmpPlayer * _Nonnull)ampPlayer metadata:(NSArray<AVMetadataItem *> * _Nonnull)metadata;
/// Callback called when seek begin
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onSeekBegan;
/// Callback called when seek end
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onSeekEnd:(NSTimeInterval)time;
/// Callback called when seek is triggered
/// \param time The timeInterval
///
- (void)onSeek:(double)currentTime :(NSTimeInterval)time;
/// Callback called when player jumps to live
- (void)onGoLive;
/// Callback called on stream forward/backword
- (void)onJumpToTime;
/// Callback called when the player is about to cancel current playback.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)willCancelPlayback:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the stream is ready to play.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)streamReadyToPlay:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the playback information changed.
/// \param ampPlayer The instance of the player that sends the event.
///
- (void)onPlaybackInformationChanged:(NSArray<AVAssetTrack *> * _Nonnull)tracks player:(AmpPlayer * _Nonnull)player;
/// Callback called when the player view is tapped.
/// \param ampPlayerManager The instance of the player that sends the event.
///
- (void)onTap:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the top bar or bottom bar is visible.
/// \param ampPlayerManager The instance of the player that sends the event.
///
- (void)onBarShown:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the top bar or bottom bar is visible.
/// \param ampPlayerManager The instance of the player that sends the event.
///
- (void)onHiddenBar:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player view is double tapped.
/// \param ampPlayerManager The instance of the player that sends the event.
///
- (void)onDoubleTap:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player enters fullscreen.
/// \param ampPlayerManager The instance of the player that sends the event.
///
- (void)onEnterFullscreen:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player exits fullscreen.
/// \param ampPlayerManager The instance of the player that sends the event.
///
- (void)onExitFullscreen:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player exits fullscreen.
/// \param ampPlayerManager The instance of the player that sends the event.
///
- (void)onToggleClosedCaption:(BOOL)isCaptionOn lang:(NSString * _Nullable)lang;
/// Callback called when the player is going to enter fullscreen, before animation starts.
/// \param ampPlayerManager The instance of the player that sends the event.
///
/// \param newFrame The new frame that the player is going to reach.
///
- (void)willEnterFullscreen:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player is going to exit fullscreen, before animation starts.
/// \param ampPlayerManager The instance of the player that sends the event.
///
/// \param newFrame The new frame that the player is going to reach.
///
- (void)willExitFullscreen:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when the player rotates.
/// \param ampPlayerManager The instance of the player that sends the event.
///
/// \param orientation The current orientation.
///
- (void)onRotate:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback called when DAI IMA ad started.
/// Only available for live streaming.
- (void)onAdPeriodStarted;
/// Callback called when DAI IMA ad ended.
/// Only available for live streaming.
- (void)onAdPeriodEnded;
/// Callback called when ad pod break is started.
- (void)onAdErrorWithError:(NSObject * _Nonnull)error;
/// Callback called when ad pod break is started.
- (void)onAdBreakStartedWithBreak:(AdBreakInfo * _Nullable)break_;
/// Callback called when an ad pod break is ended.
- (void)onAdBreakEndedWithBreak:(AdBreakInfo * _Nullable)break_;
/// Callback called when an ad is requested in a ad pod.
- (void)onAdRequested;
/// Callback called when an ad is requested in a ad pod.
- (void)onAdRequestCompleted;
/// Callback called when each Ad is started in an ad pod.
- (void)onAdStartedWithAd:(AdInfo * _Nullable)ad;
/// Callback called when each Ad is ended in an ad pod.
- (void)onAdEndedWithAd:(AdInfo * _Nullable)ad;
/// Callback called when each Ad is resumed in an ad pod.
- (void)onAdResumedWithAd:(AdInfo * _Nullable)ad;
/// Callback called when each Ad is paused in an ad pod.
- (void)onAdPausedWithAd:(AdInfo * _Nullable)ad;
/// Callback called when an Ad is skipped.
- (void)onAdSkipped;
/// Callback called when Ad time changed.
- (void)onAdProceedWithTime:(double)time;
/// Callback called when player change the mute property.
- (void)onMuteStateChangeWithIsMuted:(BOOL)isMuted;
/// Callback called when player starts a external playback
- (void)onExternalPlaybackStart:(OTTDevice * _Nullable)device;
/// Callback called when player ends a external playback.
- (void)onExternalPlaybackEnd:(OTTDevice * _Nullable)device;
/// Callback called when plugin is connecting to receiver.
- (void)onReadyToSendMetadata:(NSString * _Nonnull)deviceId status:(NSString * _Nonnull)status;
- (void)onUrlDidSet:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback triggered when an ad playing on a separate view starts
- (void)onExternalAdStarted:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback triggered when an ad playing on a separate view ends
- (void)onExternalAdEnded:(AmpPlayer * _Nonnull)ampPlayer;
/// Callback triggered on volume changes
- (void)onVolumeChanged:(AmpPlayer * _Nonnull)ampPlayer volumeLevel:(float)volumeLevel;
/// Callback triggered on avplayeritem switch
- (void)onPlayerItemChanged:(AmpPlayer * _Nonnull)ampPlayer;
@end


@interface AmpButton (SWIFT_EXTENSION(AmpCore)) <PlayerEventObserver>
- (void)streamReadyToPlay:(AmpPlayer * _Nonnull)ampPlayer;
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
@end


SWIFT_CLASS("_TtC7AmpCore14AmpCloseButton")
@interface AmpCloseButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore19AmpCurrentTimeLabel")
@interface AmpCurrentTimeLabel : UILabel
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
- (nonnull instancetype)initWithFrame:(CGRect)frame SWIFT_UNAVAILABLE;
@end


@interface AmpCurrentTimeLabel (SWIFT_EXTENSION(AmpCore)) <PlayerEventObserver>
- (void)onPositionChange:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onSeekEnd:(NSTimeInterval)time;
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
@end

@class UITouch;
@class UIEvent;

SWIFT_CLASS("_TtC7AmpCore15AmpCustomSlider")
@interface AmpCustomSlider : UIControl
@property (nonatomic) CGRect bounds;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)coder SWIFT_UNAVAILABLE;
- (void)drawRect:(CGRect)rect;
- (BOOL)beginTrackingWithTouch:(UITouch * _Nonnull)touch withEvent:(UIEvent * _Nullable)event SWIFT_WARN_UNUSED_RESULT;
- (BOOL)continueTrackingWithTouch:(UITouch * _Nonnull)touch withEvent:(UIEvent * _Nullable)event SWIFT_WARN_UNUSED_RESULT;
- (void)endTrackingWithTouch:(UITouch * _Nullable)touch withEvent:(UIEvent * _Nullable)event;
- (void)cancelTrackingWithEvent:(UIEvent * _Nullable)event;
- (nonnull instancetype)initWithFrame:(CGRect)frame SWIFT_UNAVAILABLE;
@end


@interface AmpCustomSlider (SWIFT_EXTENSION(AmpCore)) <PlayerEventObserver>
- (void)streamReadyToPlay:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onPositionChange:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onAdBreakStartedWithBreak:(AdBreakInfo * _Nullable)break_;
- (void)onSeek:(double)currentTime :(NSTimeInterval)time;
@end


SWIFT_CLASS("_TtC7AmpCore16AmpDurationLabel")
@interface AmpDurationLabel : UILabel
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
- (void)handleTouch:(id _Nonnull)sender;
- (nonnull instancetype)initWithFrame:(CGRect)frame SWIFT_UNAVAILABLE;
@end


@interface AmpDurationLabel (SWIFT_EXTENSION(AmpCore)) <PlayerEventObserver>
- (void)onBufferingStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
@end


SWIFT_CLASS("_TtC7AmpCore16AmpForwardButton")
@interface AmpForwardButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (void)onPlaybackEnded:(AmpPlayer * _Nonnull)ampPlayer;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore19AmpFullScreenButton")
@interface AmpFullScreenButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (void)onEnterFullscreen:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onExitFullscreen:(AmpPlayer * _Nonnull)ampPlayer;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore13AmpMuteButton")
@interface AmpMuteButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (void)onMuteStateChangeWithIsMuted:(BOOL)isMuted;
- (void)onVolumeChanged:(AmpPlayer * _Nonnull)ampPlayer volumeLevel:(float)volumeLevel;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore12AmpPiPButton")
@interface AmpPiPButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore17AmpPlayBackButton")
@interface AmpPlayBackButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
/// Player Event Observer Protocol
- (void)onPlaybackStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onHandledDidBecomeActive:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onExternalPlaybackChange:(AmpPlayer * _Nonnull)ampPlayer;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end

@class UIView;
@class AmpUIView;
@class PlayerUIView;

/// Main class of <code>AmpCore</code>, it handles all type of configurations and events of the player.
SWIFT_CLASS("_TtC7AmpCore9AmpPlayer")
@interface AmpPlayer : NSObject
/// Initializes a new AmpPlayer with the parameters provided.
///
/// returns:
/// A configured instance of an AmpPlayer.
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
- (nonnull instancetype)initWithParentView:(UIView * _Nonnull)parentView;
- (nonnull instancetype)initWithParentView:(UIView * _Nonnull)parentView inlineUIView:(AmpUIView * _Nonnull)inlineUIView fullScreenUIView:(AmpUIView * _Nullable)fullScreenUIView;
- (nonnull instancetype)initWithPlayerUI:(PlayerUIView * _Nonnull)playerUI;
- (nonnull instancetype)initWithParentView:(UIView * _Nonnull)parentView PlayerUI:(PlayerUIView * _Nonnull)playerUI;
@end

/// Enum representation of the media characteritics.
typedef SWIFT_ENUM(NSInteger, MediaCharacteristic, open) {
/// Close caption options
  MediaCharacteristicCloseCaptions = 0,
/// Audio tracks
  MediaCharacteristicAudio = 1,
};



@class AVPlayer;
@class AVPlayerItem;
@class Media;
enum StreamType : NSInteger;
enum PlaybackState : NSInteger;
enum BufferingState : NSInteger;
@class AmpPlayerView;
@class UIViewController;
@protocol AVPictureInPictureControllerDelegate;
@class AVPictureInPictureController;
@class NSNotification;
@class FairplayConfiguration;
@class AVURLAsset;

@interface AmpPlayer (SWIFT_EXTENSION(AmpCore))
/// This property contains a reference to the AVFoundation instance that reproduces the content.
@property (nonatomic, readonly, strong) AVPlayer * _Nullable player;
/// Enables or disables the player controls during an ad break.
/// The default value is false
@property (nonatomic) BOOL enableAdUI;
/// This property contains the current stream information
/// It is updated as soon as new values are available.
@property (nonatomic, strong) StreamInfo * _Nullable streamInfo;
/// Static value that contains the version of AmpCore currently in use.
@property (nonatomic, readonly, copy) NSString * _Nonnull version;
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly, copy) NSString * _Nonnull domain;)
+ (NSString * _Nonnull)domain SWIFT_WARN_UNUSED_RESULT;
/// License provided by Akamai
/// The preferred validation method at the moment is the API key wich is also
/// provided by Akamai. If you are interested in updating your license please open a ticket in
/// <a href="https://ampsupport.atlassian.net/">AMP Support</a>.
@property (nonatomic, copy) NSString * _Nullable licenseString;
/// This property contains a reference to the AVPlayerItem instance that holds the content being reproduced.
/// Overriding this value may result in unexpected behaviours.
@property (nonatomic, readonly, strong) AVPlayerItem * _Nullable playerItem;
/// Title of the stream.
/// This will be used on the default UI provided.
@property (nonatomic, copy) NSString * _Nullable title;
/// Subtitle of the stream.
/// This will be used on the default UI provided.
@property (nonatomic, copy) NSString * _Nullable subtitle;
/// The URL of the current main content.
@property (nonatomic, readonly, copy) NSString * _Nullable url;
/// This property will manage the media object.
/// You can use this property to initialize playback by passing the <em>AMPPlayer</em> a single
/// object.
@property (nonatomic, strong) Media * _Nullable media;
/// This flag indicates if the content should be played automatically after
/// the content has been loaded
@property (nonatomic) BOOL autoplay;
/// Flag that indicates if the Live content (with an available buffer window) should be seekable.
/// This flag is only useful for Live content. VoD content is always seekable.
/// On tvOS this value can’t be changed.
@property (nonatomic) BOOL isDVREnabled;
/// The type of stream represented as an enum.
@property (nonatomic) enum StreamType streamType;
/// The current playback state of the loaded content.
/// Overriding this value may result in unexpected behaviours.
/// <ul>
///   <li>
///     Available values: <code>PlaybackState/playing</code>,  <code>PlaybackState/paused</code>,
///     <code>PlaybackState/failed</code>,  <code>PlaybackState/stopped</code>, <code>PlaybackState/ended</code>
///   </li>
/// </ul>
@property (nonatomic) enum PlaybackState playbackState;
/// This property holds Metadata available at the current time frame
/// Metadata or ID3Tags contain additional information about the current point in the video
@property (nonatomic, copy) NSArray<AVMetadataItem *> * _Nonnull timedMetadata;
/// Current buffering state of the player
/// Overriding this value may result in unexpected behaviours.
/// <ul>
///   <li>
///     Available values: <code>BufferingState/unknown</code>,  <code>BufferingState/ready</code>,
///     <code>BufferingState/delayed</code>
///   </li>
/// </ul>
@property (nonatomic) enum BufferingState bufferingState;
/// Container of the UI of the player components and events
@property (nonatomic, strong) AmpPlayerView * _Nullable playerView;
/// Customized view for an inline player instance
@property (nonatomic, strong) AmpUIView * _Nullable inlineCustomView;
/// Customized view for a fullscren player instance
@property (nonatomic, strong) AmpUIView * _Nullable fullCustomScreenView;
/// Holds an instance of the <a href="https://developer.apple.com/documentation/uikit/uiviewcontroller">UIViewController</a>
/// that contains the player
@property (nonatomic, readonly, strong) UIViewController * _Nullable parentViewController;
/// Flag syncronized with the fullscreen state of the player
@property (nonatomic) BOOL isFullscreen;
/// Enables or disables the snapshow funcionaility when returning the app from background
/// The snapshot functionality is an image of the last frame of the video that was seen. When coming to
/// foreground if the content has to be rebuffered the user will see the snapshot instead of the empty player.
@property (nonatomic) BOOL isBackgroundSnapshotEnabled;
/// Return true or false if the player supports Picture in Picture
@property (nonatomic) BOOL isPreplaybackCoverEnabled;
/// Enables or disables the use of Picture in Picture
@property (nonatomic) BOOL isPictureInPictureEnabled;
/// Instance of the <code>AVPictureInPictureControllerDelegate</code> currently in use
/// To add your own <code>AVPictureInPictureControllerDelegate</code> use the <code>pictureInPictureDelegate</code>
@property (nonatomic, readonly, strong) id <AVPictureInPictureControllerDelegate> _Nullable pictureDelegate;
/// Instance of the <code>AVPictureInPictureController</code> currently in use
@property (nonatomic, readonly, strong) AVPictureInPictureController * _Nullable pictureController;
/// Enables or disables the use of SharePlay.
/// If enables will appear a option in the player to start/end a SharePlay session.
@property (nonatomic) BOOL isSharePlayEnabled SWIFT_AVAILABILITY(ios,introduced=15);
/// This function triggers the background mode of the player.
/// There is no need to call this function manually, when the app goes to background <code>AmpCore</code> manages
/// it automatically.
- (void)handleWillResignActive;
/// This function triggers the foreground mode of the player.
/// There is no need to call this function manually, when the app comes to foreground <code>AmpCore</code> manages
/// it automatically.
- (void)handleDidBecomeActive;
/// Setter for the player license provided by Akamai
/// In the latest version of AmpCore the use of license has become legacy in favor of the API key.
/// In case you want to provide an API key use <code>setApiKey(_:)</code> instead.
/// important:
/// If the license is invalid you won’t be able to make use of the AMPPlayer or it’s components
/// \param license String representation of the license
///
- (void)setLicense:(NSString * _Nonnull)license;
/// Setter for the player API key provided by Akamai
/// important:
/// If the license is invalid you won’t be able to make use of the AMPPlayer or its components
/// \param apiKey String representation of the API key
///
+ (void)setApiKey:(NSString * _Nonnull)apiKey;
/// Handler of the event
/// <a href="https://developer.apple.com/documentation/foundation/nsnotification/name/1388553-avplayeritemnewaccesslogentry">AVPlayerItemNewAccessLogEntry</a>
/// The event handler is triggered by the system, manual calls to this function
/// may result in unexpected behaviours.
/// \param notification Log entry event notification
///
- (void)handleAVPlayerAccess:(NSNotification * _Nonnull)notification;
/// Function to set the URL of the new content to play.
/// You can use this function to replace the current video stream. If you want to send an
/// <a href="https://developer.apple.com/documentation/avfoundation/avurlasset">AVURLAsset</a>
/// instead, use <code>play(asset:)</code>. If you want to reproduce a Fairplay stream use
/// <code>play(url:configuration:)</code> instead.
/// \param streamUrl String representation of the new URL
///
- (void)playWithUrl:(NSString * _Nonnull)streamUrl;
/// Function to start SharePlay.
/// If the user cancels the SharePlay, local playback will be used instead.
/// \param title Name of the activity in Facetime
///
/// \param streamUrl String representation of the url. Optional, this defaults to the current item
///
- (void)startSharePlayWithTitle:(NSString * _Nonnull)title url:(NSString * _Nullable)streamUrl SWIFT_AVAILABILITY(tvos,introduced=15) SWIFT_AVAILABILITY(ios,introduced=15);
/// Function to leave the SharePlay session
- (void)leaveSharePlay SWIFT_AVAILABILITY(tvos,introduced=15) SWIFT_AVAILABILITY(ios,introduced=15);
/// Function to end the SharePlay session
- (void)endSharePlay SWIFT_AVAILABILITY(tvos,introduced=15) SWIFT_AVAILABILITY(ios,introduced=15);
/// Function to complete the information required for SharePlay DRM content
/// \param url String representation of the URL
///
/// \param configuration FairplayConfiguration instance with the credentials for the stream
///
- (void)completeSharePlayDRMInformationWithUrl:(NSString * _Nonnull)url configuration:(FairplayConfiguration * _Nonnull)configuration;
/// Function to set the URL of the new content to play.
/// You can use this function to replace the current video stream. If you want to send a
/// String representation of the URL instead, use <code>play(url:)</code>. If you want to
/// reproduce a Fairplay stream use <code>play(url:configuration:)</code> instead.
/// \param streamUrl String representation of the new URL
///
- (void)playWithAsset:(AVURLAsset * _Nonnull)asset;
- (void)playWithUrl:(NSString * _Nonnull)url certificateUrl:(NSString * _Nonnull)certificateUrl serverURL:(NSString * _Nonnull)serverURL customHeaders:(NSDictionary<NSString *, NSString *> * _Nullable)customHeaders jsonResponse:(BOOL)jsonResponse SWIFT_DEPRECATED_MSG("Use play(url:configuration)");
/// Function to set the URL and credentials of the new content to play.
/// You can use this function to replace the current video stream. If your content isn’t Fairplay protected
/// use <code>play(url:)</code> or <code>play(asset:)</code>.
/// \param url String representation of the URL
///
/// \param configuration FairplayConfiguration instance with the credentials for the stream
///
- (void)playWithUrl:(NSString * _Nonnull)url configuration:(FairplayConfiguration * _Nonnull)configuration;
/// Handler of the event
/// <a href="https://developer.apple.com/documentation/foundation/nsnotification/name/1388553-avplayeritemnewaccesslogentry">AVPlayerItemNewAccessLogEntry</a>
/// The event handler is triggered by the system, manual calls to this function
/// may result in unexpected behaviours.
/// \param notification Log entry event notification
///
- (void)playerInfoChanged:(NSNotification * _Nonnull)notification;
/// Handles the event
/// <a href="https://developer.apple.com/documentation/foundation/nsnotification/name/1386566-avplayeritemdidplaytoendtime">AVPlayerItemDidPlayToEndTime</a>
/// The event handler is triggered by the system, manual calls to this function
/// may result in unexpected behaviours.
/// \param notification Notification of the event “play to end time”
///
- (void)playerItemDidPlayToEndTime:(NSNotification * _Nonnull)notification;
/// Handles the event
/// <a href="https://developer.apple.com/documentation/foundation/nsnotification/name/1387661-avplayeritemplaybackstalled">AVPlayerItemPlaybackStalled</a>
/// The event handler is triggered by the system, manual calls to this function
/// may result in unexpected behaviours.
/// \param notification Notification of the event “playback stalled”
///
- (void)playerDidStall:(NSNotification * _Nonnull)notification;
/// Check if the playhead matches the end of the video
- (BOOL)isPlaybackComplete SWIFT_WARN_UNUSED_RESULT;
/// Handler of the event when the player fails to play until the end of the video
/// <a href="https://developer.apple.com/documentation/foundation/nsnotification/name/1388007-avplayeritemfailedtoplaytoendtim">AVPlayerItemFailedToPlayToEndTime</a>
/// The event handler is triggered by the system, manual calls to this function
/// may result in unexpected behaviours.
/// \param notification Notification of the event “failed to play to end time”
///
- (void)playerItemFailedToPlayToEndTime:(NSNotification * _Nonnull)notification;
- (void)newErrorLogEntry:(NSNotification * _Nonnull)notification;
/// Forced update of the current position of the playhead
- (void)updatePosition;
/// Forced update of the current position of the playback scrub bar
- (void)changePosition;
/// Registers a new observer to be able to receive notifications of the player events.
/// To remove a single observer you will need the returned ID
/// \param observer Instance of the observer to register
///
///
/// returns:
/// ID of the registered observer
- (NSInteger)registerObserver:(id <PlayerEventObserver> _Nonnull)observer SWIFT_WARN_UNUSED_RESULT;
/// Removes a registered observer
/// \param id ID of the obeserver to delete
///
- (void)removeObserver:(NSInteger)id;
@end


/// Container class for the UI components related to playback
SWIFT_CLASS("_TtC7AmpCore13AmpPlayerView")
@interface AmpPlayerView : UIView
SWIFT_CLASS_PROPERTY(@property (nonatomic, class, readonly) Class _Nonnull layerClass;)
+ (Class _Nonnull)layerClass SWIFT_WARN_UNUSED_RESULT;
- (nonnull instancetype)initWithFrame:(CGRect)frame OBJC_DESIGNATED_INITIALIZER;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)coder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore15AmpRewindButton")
@interface AmpRewindButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore17AmpSettingsButton")
@interface AmpSettingsButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (void)onBufferingStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


/// Class in charge of handle configurations and events for SharePlay.
SWIFT_CLASS("_TtC7AmpCore12AmpSharePlay") SWIFT_AVAILABILITY(tvos,introduced=15) SWIFT_AVAILABILITY(ios,introduced=15)
@interface AmpSharePlay : NSObject
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end

@protocol SharePlayEventObserver;

SWIFT_AVAILABILITY(tvos,introduced=15) SWIFT_AVAILABILITY(ios,introduced=15)
@interface AmpSharePlay (SWIFT_EXTENSION(AmpCore))
/// Registers a new observer to be able to receive notifications of the SharePlay events.
/// To remove a single observer you will need the returned ID.
/// \param observer Instance of the observer to register.
///
///
/// returns:
/// ID of the registered observer.
- (NSInteger)registerObserver:(id <SharePlayEventObserver> _Nonnull)observer SWIFT_WARN_UNUSED_RESULT;
@end


SWIFT_CLASS("_TtC7AmpCore18AmpSharePlayButton") SWIFT_AVAILABILITY(ios,introduced=15)
@interface AmpSharePlayButton : AmpButton
- (void)handleTouch:(id _Nonnull)sender;
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
@end


SWIFT_CLASS("_TtC7AmpCore9AmpSlider")
@interface AmpSlider : UISlider
/// Set the maximum track tint.
@property (nonatomic, strong) UIColor * _Nullable maximumTrackTintColor;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
- (nonnull instancetype)initWithFrame:(CGRect)frame SWIFT_UNAVAILABLE;
@end


@interface AmpSlider (SWIFT_EXTENSION(AmpCore)) <PlayerEventObserver>
- (void)onBufferingStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
- (void)streamReadyToPlay:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onPositionChange:(AmpPlayer * _Nonnull)ampPlayer;
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
@end

typedef SWIFT_ENUM(NSInteger, AmpUIAction, open) {
  AmpUIActionClose = 0,
  AmpUIActionShare = 1,
  AmpUIActionPlay = 2,
  AmpUIActionPause = 3,
  AmpUIActionCaptions = 4,
  AmpUIActionForward = 5,
  AmpUIActionRewind = 6,
  AmpUIActionPictureinpicture = 7,
  AmpUIActionMute = 8,
  AmpUIActionUnmute = 9,
  AmpUIActionAirplay = 10,
  AmpUIActionFullscreen = 11,
  AmpUIActionShareplay = 12,
};


SWIFT_PROTOCOL("_TtP7AmpCore18AmpUIEventDelegate_")
@protocol AmpUIEventDelegate
- (void)onActionPerformedWithAction:(enum AmpUIAction)action player:(AmpPlayer * _Nullable)player;
@end


SWIFT_CLASS("_TtC7AmpCore12PlayerUIView")
@interface PlayerUIView : UIView
- (nonnull instancetype)initWithFrame:(CGRect)frame OBJC_DESIGNATED_INITIALIZER;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)coder OBJC_DESIGNATED_INITIALIZER;
- (void)didMoveToSuperview;
- (void)hide;
@end


SWIFT_CLASS("_TtC7AmpCore9AmpUIView")
@interface AmpUIView : PlayerUIView
- (nonnull instancetype)initWithFrame:(CGRect)frame OBJC_DESIGNATED_INITIALIZER;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)coder OBJC_DESIGNATED_INITIALIZER;
@end


@class UIImage;

IB_DESIGNABLE
SWIFT_CLASS("_TtC7AmpCore7BasicUI")
@interface BasicUI : AmpUIView
@property (nonatomic, strong) IBInspectable UIImage * _Nullable closeButtonImage;
@property (nonatomic) IBInspectable BOOL isHiddenCloseButton;
@property (nonatomic) IBInspectable BOOL isHiddenAirplayButton;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable rewindButtonImage;
@property (nonatomic) IBInspectable BOOL isHiddenRewindButton;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable forwardButtonImage;
@property (nonatomic) IBInspectable BOOL isHiddenForwardButton;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable playButtonImage;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable pauseButtonImage;
@property (nonatomic) IBInspectable BOOL isHiddenPlayButton;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable pictureInPictureButtonImage;
@property (nonatomic) IBInspectable BOOL isHiddenPictureInPictureButton;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable muteButtonImage;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable unMuteButtonImage;
@property (nonatomic) IBInspectable BOOL isHiddenMuteButton;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable settingsButtonImage;
@property (nonatomic) IBInspectable BOOL isHiddenSettingsButton;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable fullscreenButtonImage;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable fullscreenButtonCollapseImage;
@property (nonatomic) IBInspectable BOOL isHiddenFullscreenButton;
@property (nonatomic, copy) IBInspectable NSString * _Nonnull titleText;
@property (nonatomic, copy) IBInspectable NSString * _Nonnull subTitleText;
@property (nonatomic) IBInspectable BOOL isTitle;
@property (nonatomic) IBInspectable BOOL isSubtitle;
@property (nonatomic, strong) IBInspectable UIColor * _Nonnull bufferColor;
@property (nonatomic, strong) IBInspectable UIColor * _Nonnull maximumTrackTintColor;
@property (nonatomic, strong) IBInspectable UIColor * _Nonnull progressTintColor;
- (nonnull instancetype)initWithFrame:(CGRect)frame OBJC_DESIGNATED_INITIALIZER;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)aDecoder OBJC_DESIGNATED_INITIALIZER;
- (void)prepareForInterfaceBuilder;
@end

/// The enum representation of diferent buffering states that the content could be in.
typedef SWIFT_ENUM(NSInteger, BufferingState, open) {
/// The content either hasn’t stater yet or found an error that prevents the playback or buffering.
  BufferingStateUnknown = 0,
/// The content has enough buffer and is playable.
/// Being playable is independent to the playback state, it only means that there’s enough buffer
/// for the current item for playing for a determined period of time without rebuffering.
  BufferingStateReady = 1,
/// The content is still buffering and isn’t playable.
/// Delayed shouldn’t happen often under normal network connection conditions. AVPlayer determines
/// internally when it has enough buffer to minimize rebuffering delays, once the conditions have been
/// met the buffer will switch back to ready.
  BufferingStateDelayed = 2,
};


/// Container object for the caption specification.
SWIFT_CLASS("_TtC7AmpCore7Caption")
@interface Caption : NSObject
/// Creates a new instance of the class with it’s default values
- (nonnull instancetype)init OBJC_DESIGNATED_INITIALIZER;
@end


/// Class in charge of managing cuepoints per AmpPlayer.
SWIFT_CLASS("_TtC7AmpCore15CuepointManager")
@interface CuepointManager : NSObject <PlayerEventObserver>
- (void)onBufferingStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
/// :nodoc:
- (void)onPositionChange:(AmpPlayer * _Nonnull)ampPlayer;
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end


/// Container class of the specifications to load a Fairplay stream
SWIFT_CLASS("_TtC7AmpCore21FairplayConfiguration")
@interface FairplayConfiguration : NSObject
/// Creates a new instance of <code>FaiplayConfiguration</code> with uninitialized properties
- (nonnull instancetype)init OBJC_DESIGNATED_INITIALIZER;
@end

/// Enum representation of the provider of the Fairplay stream
typedef SWIFT_ENUM(NSInteger, FairplayProvider, open) {
/// Any provider not enumerated
  FairplayProviderCustom = 0,
  FairplayProviderVerimatrix = 1,
  FairplayProviderAzure = 2,
  FairplayProviderExpressplay = 3,
};



/// Class that contains the information of the media object
SWIFT_CLASS("_TtC7AmpCore5Media")
@interface Media : NSObject
/// Creates an instance of the Media object with default values.
- (nonnull instancetype)init OBJC_DESIGNATED_INITIALIZER;
@end




/// Container class of an OTT device connection
SWIFT_CLASS("_TtC7AmpCore9OTTDevice")
@interface OTTDevice : NSObject
/// Creates a new instance of the class with its default values
- (nonnull instancetype)init OBJC_DESIGNATED_INITIALIZER;
@end

/// The enum representation of diferent playback states that the loaded content could be in.
typedef SWIFT_ENUM(NSInteger, PlaybackState, open) {
/// The loaded content has been stopped.
/// This state could indicate that either the playback hasn’t started, or the playblack has been
/// forcefully stopped. After the playback has been force-stopped the content can’t be recovered
/// a manual <code>AmpPlayer/play(url:)</code> has to be called to restart the playback.
  PlaybackStateStopped = 0,
/// The loaded content is being watched
  PlaybackStatePlaying = 1,
/// The loaded content is paused
  PlaybackStatePaused = 2,
/// The content couldn’t be loaded due to an error
  PlaybackStateFailed = 3,
/// The content has been played until the end time
  PlaybackStateEnded = 4,
};

/// Enum to manage the errors on the player.
/// <ul>
///   <li>
///     UnknownAssetFormat: For assets with a incorrect format.
///   </li>
///   <li>
///     DownloadFailed: When the asset can’t download.
///   </li>
///   <li>
///     UnknownError: For unknown errors.
///   </li>
/// </ul>
typedef SWIFT_ENUM(NSInteger, PlayerError, open) {
/// UnknownAssetFormat: For assets with a incorrect format.
  PlayerErrorUnknownAssetFormat = 0,
/// DownloadFailed: When the asset can’t download.
  PlayerErrorDownloadFailed = 1,
/// UnknownError: For unknown errors.
  PlayerErrorUnknownError = 2,
/// PlayerItemFailedToPlayToEnd: Asset failed to finish playback
  PlayerErrorPlayerItemFailedToPlayToEnd = 3,
/// PlayerItemErrorLog: New AVPlayerItemErrorLog
  PlayerErrorPlayerItemErrorLog = 4,
/// InvalidLicense: Invalid or Expired License
  PlayerErrorInvalidLicense = 5,
/// No Network Connection
  PlayerErrorNetworkConnectionError = 6,
/// Invalid CKC
  PlayerErrorDrmCKCFailed = 7,
/// Invalid Certificate
  PlayerErrorDrmInvalidCertificate = 8,
/// Invalid Asset Id
  PlayerErrorDrmInvalidAssetId = 9,
/// Invalid CKC from KSM
  PlayerErrorDrmNotValidCKCFromKSM = 10,
/// No data from loading request
  PlayerErrorDrmNoData = 11,
/// No data from loading request
  PlayerErrorDvrNoDuration = 12,
};
static NSString * _Nonnull const PlayerErrorDomain = @"AmpCore.PlayerError";


SWIFT_CLASS("_TtC7AmpCore17PlayerEventLogger")
@interface PlayerEventLogger : NSObject <PlayerEventObserver>
/// :nodoc:
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
/// :nodoc:
- (void)onHandledResignActive:(AmpPlayer * _Nonnull)ampPlayer;
/// :nodoc:
- (void)onHandledDidBecomeActive:(AmpPlayer * _Nonnull)ampPlayer;
/// :nodoc:
- (void)willHandleUrl:(AmpPlayer * _Nonnull)ampPlayer;
/// :nodoc:
- (void)onPlaybackStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
/// :nodoc:
- (void)onBufferingStateChanged:(AmpPlayer * _Nonnull)ampPlayer;
/// :nodoc:
- (void)onCuepointReached:(AmpPlayer * _Nonnull)ampPlayer atTime:(double)atTime;
/// :nodoc:
- (void)onPlaybackStalled:(AmpPlayer * _Nonnull)ampPlayer;
/// :nodoc:
- (void)onPlaybackEnded:(AmpPlayer * _Nonnull)ampPlayer;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end



IB_DESIGNABLE
SWIFT_CLASS("_TtC7AmpCore8PlayerUI")
@interface PlayerUI : PlayerUIView
@property (nonatomic) IBInspectable BOOL airplayIsHidden;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable rewindImage;
@property (nonatomic) IBInspectable BOOL rewindIsHidden;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable forwardImage;
@property (nonatomic) IBInspectable BOOL forwardIsHidden;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable playImage;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable pauseImage;
@property (nonatomic) IBInspectable BOOL playIsHidden;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable pipImage;
@property (nonatomic) IBInspectable BOOL pipIsHidden;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable startSharePlayImage SWIFT_AVAILABILITY(ios,introduced=15);
@property (nonatomic, strong) IBInspectable UIImage * _Nullable endSharePlayImage SWIFT_AVAILABILITY(ios,introduced=15);
@property (nonatomic) IBInspectable BOOL sharePlayIsHidden SWIFT_AVAILABILITY(ios,introduced=15);
@property (nonatomic, strong) IBInspectable UIImage * _Nullable muteImage;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable unMuteImage;
@property (nonatomic) IBInspectable BOOL muteIsHidden;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable settingsImage;
@property (nonatomic) IBInspectable BOOL settingsIsHidden;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable fullscreenImage;
@property (nonatomic, strong) IBInspectable UIImage * _Nullable collapseImage;
@property (nonatomic) IBInspectable BOOL fullscreenIsHidden;
@property (nonatomic, copy) IBInspectable NSString * _Nonnull titleText;
@property (nonatomic, copy) IBInspectable NSString * _Nonnull subTitleText;
@property (nonatomic) IBInspectable BOOL isTitleHidden;
@property (nonatomic) IBInspectable BOOL isSubtitleHidden;
@property (nonatomic, strong) IBInspectable UIColor * _Nonnull bufferColor;
@property (nonatomic, strong) IBInspectable UIColor * _Nonnull maximumTrackTintColor;
@property (nonatomic, strong) IBInspectable UIColor * _Nonnull progressTintColor;
@property (nonatomic) IBInspectable CGFloat progressBarInset;
- (nonnull instancetype)initWithFrame:(CGRect)frame OBJC_DESIGNATED_INITIALIZER;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)coder OBJC_DESIGNATED_INITIALIZER;
- (void)prepareForInterfaceBuilder;
@end



@interface PlayerUIView (SWIFT_EXTENSION(AmpCore)) <PlayerEventObserver>
- (void)willStop:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onTap:(AmpPlayer * _Nonnull)ampPlayer;
- (void)onSeekBegan;
- (void)onSeekEnd:(NSTimeInterval)time;
@end


/// Container class for the player’s poster
SWIFT_CLASS("_TtC7AmpCore11PosterImage")
@interface PosterImage : NSObject
/// Image that will be displayed over the video frame
@property (nonatomic, strong) UIImage * _Nullable image;
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end

/// The enum representation of the <code>PosterImage</code> display behaviour
typedef SWIFT_ENUM(NSInteger, PosterImageType, open) {
/// The image will be displayed when the stream is audio-only
  PosterImageTypePoster = 0,
/// The image will be displayed when the content is stalled
/// Once the the buffer is <code>BufferingState/ready</code> the poster will be hidden
  PosterImageTypeStreamAutoRecovery = 1,
};


SWIFT_CLASS("_TtC7AmpCore20SelectorWithInterval")
@interface SelectorWithInterval : NSObject
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end

@class NSBundle;

SWIFT_CLASS("_TtC7AmpCore22SettingsViewController")
@interface SettingsViewController : UIViewController
@property (nonatomic, readonly) BOOL prefersStatusBarHidden;
- (void)viewDidLoad;
- (nonnull instancetype)initWithNibName:(NSString * _Nullable)nibNameOrNil bundle:(NSBundle * _Nullable)nibBundleOrNil OBJC_DESIGNATED_INITIALIZER;
- (nullable instancetype)initWithCoder:(NSCoder * _Nonnull)coder OBJC_DESIGNATED_INITIALIZER;
@end

@class UITableView;
@class NSIndexPath;
@class UITableViewCell;

@interface SettingsViewController (SWIFT_EXTENSION(AmpCore)) <UITableViewDataSource, UITableViewDelegate>
- (NSInteger)tableView:(UITableView * _Nonnull)tableView numberOfRowsInSection:(NSInteger)section SWIFT_WARN_UNUSED_RESULT;
- (UITableViewCell * _Nonnull)tableView:(UITableView * _Nonnull)tableView cellForRowAtIndexPath:(NSIndexPath * _Nonnull)indexPath SWIFT_WARN_UNUSED_RESULT;
- (NSInteger)numberOfSectionsInTableView:(UITableView * _Nonnull)tableView SWIFT_WARN_UNUSED_RESULT;
- (NSString * _Nullable)tableView:(UITableView * _Nonnull)tableView titleForHeaderInSection:(NSInteger)section SWIFT_WARN_UNUSED_RESULT;
- (void)tableView:(UITableView * _Nonnull)tableView willDisplayHeaderView:(UIView * _Nonnull)view forSection:(NSInteger)section;
- (void)tableView:(UITableView * _Nonnull)tableView didSelectRowAtIndexPath:(NSIndexPath * _Nonnull)indexPath;
@end


/// Protocol used to receive SharePlay events.
SWIFT_PROTOCOL("_TtP7AmpCore22SharePlayEventObserver_") SWIFT_AVAILABILITY(tvos,introduced=15) SWIFT_AVAILABILITY(ios,introduced=15)
@protocol SharePlayEventObserver
@optional
/// Callback triggered when AMP requires additional information for playback on SharePlay.
- (void)additionalInformationRequired:(AmpPlayer * _Nonnull)ampPlayer url:(NSString * _Nonnull)url;
@end


/// This protocol needs to be implemented for creating a handler for a specific <code>AmpCore/StreamType</code>
SWIFT_PROTOCOL("_TtP7AmpCore13StreamHandler_")
@protocol StreamHandler
/// This function determines if the implementing class should be the handler of an URL
/// \param url The new URL that will be replacing the main content
///
///
/// returns:
/// <code>true</code> if the handler will be handling the URL <code>false</code> otherwise
- (BOOL)canHandleUrlWithUrl:(NSString * _Nonnull)url SWIFT_WARN_UNUSED_RESULT;
@optional
/// This function will be called to start the handling of an URL
/// When implementing this function create a new <em>AVPlayerItem</em> and replace the current
/// <code>AmpCore/AmpPlayer/player</code>’s item.
/// \param url The URL that will replace the main content
///
/// \param player The <code>AmpCore/AmpPlayer</code> that is going to replace its main content
///
/// \param success This closure will be called if the handling of the URL was successful
///
/// \param failure This closure shoudl be called if the handling of the URL failed
///
- (void)handleUrlWithUrl:(NSString * _Nonnull)url player:(AmpPlayer * _Nonnull)player success:(void (^ _Nonnull)(AVPlayerItem * _Nullable))success failure:(void (^ _Nonnull)(enum PlayerError))failure;
/// This function will be called to start the handling of an AVURLAsset
/// When implementing this function create a new <em>AVPlayerItem</em> and replace the current
/// <code>AmpCore/AmpPlayer/player</code>’s item.
/// \param asset The <em>AVURLAsset</em> that will replace the main content
///
/// \param player The <code>AmpCore/AmpPlayer</code> that is going to replace its main content
///
/// \param success This closure will be called if the handling of the URL was successful
///
/// \param failure This closure shoudl be called if the handling of the URL failed
///
- (void)handleAVURLAssetWithAsset:(AVURLAsset * _Nonnull)asset player:(AmpPlayer * _Nonnull)player success:(void (^ _Nonnull)(AVPlayerItem * _Nullable))success failure:(void (^ _Nonnull)(enum PlayerError))failure;
@required
/// This function describes the type of stream the handler is meant for
///
/// returns:
/// The <code>AmpCore/StreamType</code> that the handler is managing
- (enum StreamType)getStreamType SWIFT_WARN_UNUSED_RESULT;
@end


/// Contains all the information related to the current content.
SWIFT_CLASS("_TtC7AmpCore10StreamInfo")
@interface StreamInfo : NSObject
- (nonnull instancetype)init SWIFT_UNAVAILABLE;
+ (nonnull instancetype)new SWIFT_UNAVAILABLE_MSG("-init is unavailable");
@end

/// Enum representation of a type of stream.
typedef SWIFT_ENUM(NSInteger, StreamType, open) {
/// Used for streams retrieved through an URL
  StreamTypeHttp = 0,
/// Unknown stream.
/// This is the default initial vaule of <code>StreamInfo</code>, anything that won’t override
/// this value will be categorized as it.
  StreamTypeUnknown = 1,
/// Used for streams retrieved from a config file
  StreamTypeConfig = 2,
/// Used for locally stored streams
  StreamTypeLocal = 3,
/// Used for DRM protected content
/// Supported types of DRM content includes Fairplay, Verimatrix, ExpressPlay, and Azure.
  StreamTypeDrm = 4,
/// Used on audio-only content.
  StreamTypeAudio = 5,
};












#endif
#if defined(__cplusplus)
#endif
#if __has_attribute(external_source_symbol)
# pragma clang attribute pop
#endif
#pragma clang diagnostic pop
#endif

#else
#error unsupported Swift architecture
#endif
